<?php
/*
Plugin Name: Simple Facebook Badge Widgets
Plugin URI: http://www.qxdev.com/2011/03/integrating-facebook-badges-widgets-wordpress-php-architect
Description: A nice little plugin to add Facebook Badge widgets to your site.
Version: 1.0 Beta
Author: Valentin Secades
Author URI: http://www.linkedin.com/in/valentinsecades
License: GPL2/MIT - Get it, it's free
*/
//turned on for dev purposes
//error_reporting(E_ALL);
add_action("widgets_init", array('SFBW', 'registerWidget'));
register_activation_hook( __FILE__, array('SFBW', 'activatePlugin'));
register_deactivation_hook( __FILE__, array('SFBW', 'deactivatePlugin'));
class SFBW {
   private $aData=array();
   /*
    * Main control panel for the widget.  Offers a method to perform saving data operations if necessary.
    */
   function controlPanel(){
      if (isset($_POST['sfbw_title'])){
         $aOptionData['sfbw_title'] = $_POST['sfbw_title'];
         $aOptionData['sfbw_facebook_code'] = $_POST['sfbw_facebook_code'];
         update_option('SFBW', $aOptionData);
      }
      $aOptionData = SFBW::_extractValues();
      ?>
      <p><label for="sfbw_title">Title:</label><input id="sfbw_title" name="sfbw_title" type="text" value="<?php echo $aOptionData['sfbw_title']; ?>" class="widefat" /></p>
      <p><label for="sfbw_facebook_code">Facebook Badge:</label>
      <textarea name="sfbw_facebook_code" rows="16" cols="20" class="widefat" ><?php echo $aOptionData['sfbw_facebook_code']; ?></textarea>
     <?php
   }
   

   /**
    * Helper function used to perform the extraction and cleanup of the content for the SFBW array
    */
   static function _extractValues(){
      $aOptionData = get_option('SFBW');
      $aOptionData = stripslashes_deep($aOptionData);
      return $aOptionData;
   }	
   /**
    * Method called to activate the plugin, adds what we need to the options table to get
    * things started.
    */
   function activatePlugin(){
      $aOptionData = array( 'sfbw_title' => '' ,'sfbw_facebook_code' => 'Add your facebook badge here.');
      if ( ! get_option('SFBW')){
      add_option('SFBW' , $aOptionData);
      } else {
         update_option('SFBW' , $aOptionData);
      }
   }
   
   /**
    * Used as a helper method, does cleanup work to remove whatever the plugin has added to your install
    */
   function deactivatePlugin(){
      delete_option('SFBW');
   }
   /**
    * 
    * Used to generate the specific widget in the sidebar.  Takes $args with all Worpress hand me 
    * downs for creation of widget content look and feel.
    * @param Array $args
    */
   function SFBW_widget($args){
      $aOptionData = SFBW::_extractValues();
   echo $args['before_widget'];
   echo $args['before_title'] . ($aOptionData["sfbw_title"]) . $args['after_title'];
   echo $aOptionData["sfbw_facebook_code"];
   echo $args['after_widget'];
   }
   /**
    * Performs the widget registration processes, for both the control and the actual front end sidebar widget
    * content creation.
    */
   function registerWidget(){
   wp_register_sidebar_widget('SFBW-2011','SFBW', array('SFBW', 'SFBW_widget'));
   wp_register_widget_control('SFBW-2011','SFBW', array('SFBW', 'controlPanel'), array('width'=>400, 'height'=>250, 'description'=>"Widget to add Facebook badge code to your sidebars."));    	
   }
}

?>
